/*
	Routines for determining the channel id

AUTHOR:		L. A. Coon
ORGANIZATION:	Rochester Institute of Technology
EMAIL:		lac@cs.rit.edu

COPYRIGHT:	1994 Lawrence A. Coon
		All rights reserved.

		Permission to copy or use this software without fee is granted
		to non-profit and not-for-profit institutions and organizations
		provided that:

		1) such copying or use is not for commercial advantage, and
		2) no portion of this software is incorporated into any other
                   program or device for commercial advantage, and
		3) this copyright notice remains with the software.

		Permission is also granted to make this software available to
		other non-profit or not-for-profit institutions and
		organizations whose use satisfies (1) through (3) above.
		Any use of this software for commercial advantage, or
		incorporation of any part of this software into any other
		program or device for commercial advantage, or any use
		or copying other than by non-profit or not-for-profit
		institutions or organizations requires written permission of
		the copyright holder.

WARRANTY:	This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY.  Neither the author nor distributor
		accepts responsibility to anyone for the consequences of using
		it or for whether it serves any particular purpose or works at
		all.
*/

#include <stdio.h>

extern int instr_no;

save_channel(node,port)
int node, port;
{
char channel[10];
int len;

	itoa(node,channel);
	len = strlen(channel);
	channel[len] = '.';
	itoa(port,channel+len+1);
	if (! bsadd(channel))
		fprintf(stderr, "duplicate channel in instruction number %d\n",
				instr_no);
}
 
itoa(integer,string)
int integer;
char string[10];
{
int i = 0;
int j, tmp;

	/* convert to characters and save -- in reverse order */
	do {
		string[i++] = integer % 10 + '0';
	} while((integer /= 10) > 0);
	string[i] = NULL;

	/* now reverse it to get the proper order */
	for (i=0, j=strlen(string)-1; i<j; i++, j--)
	{
		tmp = string[i];
		string[i] = string[j];
		string[j] = tmp;
	}
}
