# include "stdio.h"
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
/*
	lex translator -- data flow graph code -> occam 2

AUTHOR:		L. A. Coon
ORGANIZATION:	Rochester Institute of Technology
EMAIL:		lac@cs.rit.edu

COPYRIGHT:	1994 Lawrence A. Coon
		All rights reserved.

		Permission to copy or use this software without fee is granted
		to non-profit and not-for-profit institutions and organizations
		provided that:

		1) such copying or use is not for commercial advantage, and
		2) no portion of this software is incorporated into any other
                   program or device for commercial advantage, and
		3) this copyright notice remains with the software.

		Permission is also granted to make this software available to
		other non-profit or not-for-profit institutions and
		organizations whose use satisfies (1) through (3) above.
		Any use of this software for commercial advantage, or
		incorporation of any part of this software into any other
		program or device for commercial advantage, or any use
		or copying other than by non-profit or not-for-profit
		institutions or organizations requires written permission of
		the copyright holder.

WARRANTY:	This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY.  Neither the author nor distributor
		accepts responsibility to anyone for the consequences of using
		it or for whether it serves any particular purpose or works at
		all.
*/

#include <stdio.h>
#include "y.tab.h"

extern int lineno;
extern int yylval;
extern char *message;	/* holds message associated with an IO process  */
extern double value;	/* holds double associated with a constant      */
char *strdup();
double atof();
int atoi();

/* handle binary ops by returning BIOP, and setting a pointer to the
   actual opcode -- to keep yacc tables small				*/
char *opcode_ptr;

# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
return CONST;
break;
case 2:
return MCONST;
break;
case 3:
return INPUT;
break;
case 4:
return MINPUT;
break;
case 5:
return COPY;
break;
case 6:
return MERGE;
break;
case 7:
return XMERGE;
break;
case 8:
return OUTPUT;
break;
case 9:
return MESSAGE;
break;
case 10:
return SWITCH;
break;
case 11:
return NOT;
break;
case 12:
return NEG;
break;
case 13:
{
	opcode_ptr = "Fgate";
	return BIOP;
	}
break;
case 14:
{
	opcode_ptr = "Tgate";
	return BIOP;
	}
break;
case 15:
{
	opcode_ptr = "And";
	return BIOP;
	}
break;
case 16:
{
	opcode_ptr = "Or";
	return BIOP;
	}
break;
case 17:
{
	opcode_ptr = "Eq";
	return BIOP;
	}
break;
case 18:
{
	opcode_ptr = "Ge";
	return BIOP;
	}
break;
case 19:
{
	opcode_ptr = "Le";
	return BIOP;
	}
break;
case 20:
{
	opcode_ptr = "Lt";
	return BIOP;
	}
break;
case 21:
{
	opcode_ptr = "Gt";
	return BIOP;
	}
break;
case 22:
{
	opcode_ptr = "Ne";
	return BIOP;
	}
break;
case 23:
{
	opcode_ptr = "Add";
	return BIOP;
	}
break;
case 24:
{
	opcode_ptr = "Sub";
	return BIOP;
	}
break;
case 25:
{
	opcode_ptr = "Mul";
	return BIOP;
	}
break;
case 26:
{
	opcode_ptr = "Div";
	return BIOP;
	}
break;
case 27:
{
	opcode_ptr = "Mod";
	return BIOP;
	}
break;
case 28:
{
	yylval = atoi(yytext);
	return INT;
	}
break;
case 29:
{ /* needs digits on both sides of the dot */
	value = atof(yytext);
	return REAL;
	}
break;
case 30:
{
	if ((message = strdup(yytext)) == NULL)
	{
		fprintf(stderr, "strdup failed\n");
		exit(1);
	}
	return STRING; /* character set dependent */
	}
break;
case 31:
;
break;
case 32:
{
		lineno++;	/* ignore full line comments */
	}
break;
case 33:
{
		lineno++;
		return EOS;	/* ignore comments in statements */
	}
break;
case 34:
  {
		lineno++;	/* ignore blank lines */
	}
break;
case 35:
{
		lineno++;
		return EOS;
	}
break;
case 36:
{
	return OTHER;
	}
break;
case 37:
{
	printf("ERROR, illegal character %d\n",yytext[0]);
	exit(1);
	}
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */
FILE *fopen();

FILE *lexopen(s)
char *s;
{
	return yyin = fopen(s,"r");
}

lexrewind()
{
	rewind(yyin);
}
int yyvstop[] = {
0,

37,
0,

31,
37,
0,

35,
0,

37,
0,

37,
0,

37,
0,

28,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

34,
35,
0,

37,
0,

31,
0,

28,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

17,
36,
0,

36,
0,

18,
36,
0,

21,
36,
0,

36,
0,

19,
36,
0,

20,
36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

22,
36,
0,

36,
0,

16,
36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

30,
0,

33,
0,

29,
0,

23,
36,
0,

15,
36,
0,

36,
0,

36,
0,

26,
36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

27,
36,
0,

25,
36,
0,

12,
36,
0,

11,
36,
0,

36,
0,

24,
36,
0,

36,
0,

36,
0,

36,
0,

32,
33,
0,

36,
0,

5,
36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

29,
0,

1,
36,
0,

13,
36,
0,

3,
36,
0,

36,
0,

6,
36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

14,
36,
0,

36,
0,

2,
36,
0,

36,
0,

4,
36,
0,

8,
36,
0,

10,
36,
0,

7,
36,
0,

9,
36,
0,
0};
# define YYTYPE char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,3,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,4,	1,5,	
0,0,	4,27,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	1,4,	1,3,	1,6,	
4,27,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
1,7,	0,0,	1,8,	8,30,	
0,0,	1,9,	7,29,	7,29,	
7,29,	7,29,	7,29,	7,29,	
7,29,	7,29,	7,29,	7,29,	
26,58,	29,31,	0,0,	0,0,	
0,0,	0,0,	1,10,	1,11,	
1,12,	1,13,	1,14,	1,15,	
1,16,	1,11,	1,17,	1,11,	
1,11,	1,18,	1,19,	1,20,	
1,21,	1,11,	1,11,	1,11,	
1,22,	1,23,	1,11,	1,11,	
1,11,	1,24,	1,11,	1,11,	
0,0,	0,0,	61,83,	0,0,	
0,0,	0,0,	1,11,	1,11,	
1,11,	1,11,	1,11,	1,11,	
1,11,	1,11,	1,11,	1,11,	
1,11,	1,11,	1,11,	1,11,	
1,11,	1,11,	1,11,	1,11,	
1,11,	1,11,	1,11,	1,11,	
1,11,	1,11,	1,11,	1,11,	
2,25,	9,31,	61,83,	9,32,	
9,32,	9,32,	9,32,	9,32,	
9,32,	9,32,	9,32,	9,32,	
9,32,	11,33,	0,0,	12,33,	
0,0,	13,33,	14,33,	0,0,	
16,33,	16,40,	13,37,	11,33,	
2,6,	12,33,	12,36,	13,33,	
14,33,	15,33,	16,33,	14,38,	
15,39,	17,33,	33,33,	2,26,	
16,41,	18,33,	18,43,	15,33,	
20,33,	20,50,	23,33,	17,42,	
33,33,	23,56,	0,0,	18,33,	
0,0,	34,62,	20,33,	20,51,	
23,33,	18,44,	0,0,	0,0,	
2,11,	2,12,	2,13,	34,33,	
2,15,	2,16,	2,11,	2,17,	
2,11,	2,11,	2,18,	2,19,	
2,20,	2,21,	2,11,	2,11,	
2,11,	2,22,	2,23,	2,11,	
2,11,	2,11,	2,24,	2,11,	
2,11,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2,11,	
2,11,	2,11,	2,11,	2,11,	
2,11,	2,11,	2,11,	2,11,	
2,11,	2,11,	2,11,	2,11,	
2,11,	2,11,	2,11,	2,11,	
2,11,	2,11,	2,11,	2,11,	
2,11,	2,11,	2,11,	2,11,	
2,11,	6,0,	6,0,	6,0,	
6,0,	6,0,	6,0,	6,0,	
6,0,	6,0,	6,0,	6,0,	
6,0,	6,0,	6,0,	6,0,	
6,0,	6,0,	6,0,	6,0,	
6,0,	6,0,	6,0,	6,0,	
6,0,	6,0,	6,0,	6,0,	
6,0,	6,0,	6,0,	6,0,	
6,28,	6,28,	19,45,	19,33,	
19,46,	21,33,	0,0,	22,33,	
19,47,	0,0,	0,0,	6,28,	
0,0,	19,33,	19,48,	21,33,	
6,28,	22,33,	24,33,	21,52,	
19,49,	35,63,	21,53,	0,0,	
22,54,	38,33,	22,55,	24,57,	
24,33,	0,0,	0,0,	35,33,	
0,0,	6,28,	0,0,	38,33,	
0,0,	6,28,	31,61,	31,61,	
31,61,	31,61,	31,61,	31,61,	
31,61,	31,61,	31,61,	31,61,	
36,33,	39,67,	0,0,	40,33,	
39,33,	41,33,	0,0,	0,0,	
0,0,	0,0,	36,64,	0,0,	
36,65,	40,33,	39,33,	41,33,	
10,33,	10,33,	10,33,	10,33,	
10,33,	10,33,	10,33,	10,33,	
10,33,	10,33,	10,33,	10,33,	
10,33,	10,33,	10,33,	10,33,	
10,33,	10,33,	10,33,	10,33,	
10,33,	10,33,	10,33,	10,33,	
10,33,	10,33,	0,0,	0,0,	
0,0,	0,0,	0,0,	6,0,	
10,33,	10,33,	10,33,	10,34,	
10,33,	10,33,	10,33,	10,33,	
10,33,	10,33,	10,33,	10,33,	
10,33,	10,35,	10,33,	10,33,	
10,33,	10,33,	10,33,	10,33,	
10,33,	10,33,	10,33,	10,33,	
10,33,	10,33,	28,0,	28,0,	
28,0,	28,0,	28,0,	28,0,	
28,0,	28,0,	28,0,	28,0,	
28,0,	28,0,	28,0,	28,0,	
28,0,	28,0,	28,0,	28,0,	
28,0,	28,0,	28,0,	28,0,	
28,0,	28,0,	28,0,	28,0,	
28,0,	28,0,	28,0,	28,0,	
28,0,	30,30,	37,33,	28,59,	
42,33,	43,33,	0,0,	44,33,	
45,33,	30,30,	30,60,	46,33,	
37,33,	47,33,	42,33,	43,33,	
42,68,	44,33,	45,33,	45,69,	
37,66,	46,33,	0,0,	47,72,	
48,73,	46,70,	46,71,	49,33,	
50,33,	51,33,	52,33,	50,75,	
30,30,	30,30,	48,33,	49,74,	
53,33,	49,33,	50,33,	51,33,	
52,33,	62,33,	54,78,	30,30,	
54,33,	51,76,	53,33,	0,0,	
30,30,	63,33,	55,33,	62,33,	
53,77,	56,80,	54,33,	55,79,	
56,33,	57,33,	57,81,	63,33,	
55,33,	0,0,	58,58,	64,33,	
65,33,	30,30,	56,33,	57,33,	
0,0,	30,30,	58,58,	58,82,	
66,33,	64,33,	65,33,	0,0,	
67,33,	69,33,	64,84,	0,0,	
68,33,	70,33,	66,33,	0,0,	
70,89,	65,85,	67,33,	69,88,	
71,33,	72,33,	68,33,	70,33,	
67,86,	58,58,	58,58,	73,33,	
28,0,	68,87,	71,33,	72,33,	
74,33,	72,91,	75,33,	71,90,	
58,58,	73,33,	76,33,	77,33,	
78,33,	58,58,	74,33,	79,33,	
75,33,	80,33,	81,33,	85,33,	
76,33,	77,33,	78,33,	77,92,	
0,0,	79,33,	0,0,	80,33,	
81,33,	85,33,	58,58,	79,93,	
81,95,	80,94,	58,58,	59,0,	
59,0,	59,0,	59,0,	59,0,	
59,0,	59,0,	59,0,	59,0,	
59,0,	59,0,	59,0,	59,0,	
59,0,	59,0,	59,0,	59,0,	
59,0,	59,0,	59,0,	59,0,	
59,0,	59,0,	59,0,	59,0,	
59,0,	59,0,	59,0,	59,0,	
59,0,	59,0,	0,0,	83,96,	
59,59,	83,96,	0,0,	0,0,	
83,97,	83,97,	83,97,	83,97,	
83,97,	83,97,	83,97,	83,97,	
83,97,	83,97,	84,33,	86,33,	
86,99,	87,33,	91,33,	88,33,	
0,0,	89,33,	89,102,	90,103,	
84,33,	86,33,	90,33,	87,33,	
91,33,	88,33,	84,98,	89,33,	
92,33,	87,100,	88,101,	91,104,	
90,33,	93,106,	93,33,	0,0,	
94,33,	94,107,	92,33,	95,33,	
0,0,	0,0,	95,108,	0,0,	
93,33,	92,105,	94,33,	0,0,	
0,0,	95,33,	96,97,	96,97,	
96,97,	96,97,	96,97,	96,97,	
96,97,	96,97,	96,97,	96,97,	
98,33,	99,33,	100,33,	101,33,	
102,33,	103,33,	104,33,	105,33,	
103,110,	0,0,	98,33,	99,33,	
100,33,	101,33,	102,33,	103,33,	
104,33,	105,33,	107,33,	101,109,	
106,33,	109,33,	104,111,	105,112,	
106,113,	108,33,	108,114,	111,33,	
107,33,	59,0,	106,33,	109,33,	
110,33,	110,115,	112,33,	108,33,	
113,33,	111,33,	114,33,	115,33,	
0,0,	0,0,	110,33,	0,0,	
112,33,	0,0,	113,33,	0,0,	
114,33,	115,33,	0,0,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-114,	yysvec+1,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+4,	0,		yyvstop+3,
yycrank+0,	0,		yyvstop+6,
yycrank+-236,	0,		yyvstop+8,
yycrank+2,	0,		yyvstop+10,
yycrank+2,	yysvec+7,	yyvstop+12,
yycrank+79,	0,		yyvstop+14,
yycrank+267,	0,		yyvstop+17,
yycrank+37,	yysvec+10,	yyvstop+20,
yycrank+39,	yysvec+10,	yyvstop+23,
yycrank+41,	yysvec+10,	yyvstop+26,
yycrank+42,	yysvec+10,	yyvstop+29,
yycrank+53,	yysvec+10,	yyvstop+32,
yycrank+44,	yysvec+10,	yyvstop+35,
yycrank+57,	yysvec+10,	yyvstop+38,
yycrank+61,	yysvec+10,	yyvstop+41,
yycrank+171,	yysvec+10,	yyvstop+44,
yycrank+64,	yysvec+10,	yyvstop+47,
yycrank+173,	yysvec+10,	yyvstop+50,
yycrank+175,	yysvec+10,	yyvstop+53,
yycrank+66,	yysvec+10,	yyvstop+56,
yycrank+186,	yysvec+10,	yyvstop+59,
yycrank+0,	0,		yyvstop+62,
yycrank+15,	yysvec+7,	yyvstop+65,
yycrank+0,	yysvec+4,	yyvstop+67,
yycrank+-389,	yysvec+6,	0,	
yycrank+15,	yysvec+7,	0,	
yycrank+-420,	0,		0,	
yycrank+258,	0,		0,	
yycrank+0,	yysvec+9,	yyvstop+69,
yycrank+58,	yysvec+10,	yyvstop+71,
yycrank+73,	yysvec+10,	yyvstop+73,
yycrank+189,	yysvec+10,	yyvstop+75,
yycrank+216,	yysvec+10,	yyvstop+77,
yycrank+322,	yysvec+10,	yyvstop+79,
yycrank+193,	yysvec+10,	yyvstop+81,
yycrank+220,	yysvec+10,	yyvstop+84,
yycrank+219,	yysvec+10,	yyvstop+86,
yycrank+221,	yysvec+10,	yyvstop+89,
yycrank+324,	yysvec+10,	yyvstop+92,
yycrank+325,	yysvec+10,	yyvstop+94,
yycrank+327,	yysvec+10,	yyvstop+97,
yycrank+328,	yysvec+10,	yyvstop+100,
yycrank+331,	yysvec+10,	yyvstop+102,
yycrank+333,	yysvec+10,	yyvstop+104,
yycrank+344,	yysvec+10,	yyvstop+106,
yycrank+347,	yysvec+10,	yyvstop+108,
yycrank+348,	yysvec+10,	yyvstop+110,
yycrank+349,	yysvec+10,	yyvstop+113,
yycrank+350,	yysvec+10,	yyvstop+115,
yycrank+356,	yysvec+10,	yyvstop+118,
yycrank+364,	yysvec+10,	yyvstop+120,
yycrank+370,	yysvec+10,	yyvstop+122,
yycrank+376,	yysvec+10,	yyvstop+124,
yycrank+377,	yysvec+10,	yyvstop+126,
yycrank+-481,	0,		0,	
yycrank+-550,	yysvec+6,	yyvstop+128,
yycrank+0,	0,		yyvstop+130,
yycrank+25,	yysvec+31,	yyvstop+132,
yycrank+361,	yysvec+10,	yyvstop+134,
yycrank+369,	yysvec+10,	yyvstop+137,
yycrank+383,	yysvec+10,	yyvstop+140,
yycrank+384,	yysvec+10,	yyvstop+142,
yycrank+392,	yysvec+10,	yyvstop+144,
yycrank+396,	yysvec+10,	yyvstop+147,
yycrank+400,	yysvec+10,	yyvstop+149,
yycrank+397,	yysvec+10,	yyvstop+151,
yycrank+401,	yysvec+10,	yyvstop+153,
yycrank+408,	yysvec+10,	yyvstop+155,
yycrank+409,	yysvec+10,	yyvstop+157,
yycrank+415,	yysvec+10,	yyvstop+159,
yycrank+420,	yysvec+10,	yyvstop+162,
yycrank+422,	yysvec+10,	yyvstop+165,
yycrank+426,	yysvec+10,	yyvstop+168,
yycrank+427,	yysvec+10,	yyvstop+171,
yycrank+428,	yysvec+10,	yyvstop+173,
yycrank+431,	yysvec+10,	yyvstop+176,
yycrank+433,	yysvec+10,	yyvstop+178,
yycrank+434,	yysvec+10,	yyvstop+180,
yycrank+0,	0,		yyvstop+182,
yycrank+540,	0,		0,	
yycrank+498,	yysvec+10,	yyvstop+185,
yycrank+435,	yysvec+10,	yyvstop+187,
yycrank+499,	yysvec+10,	yyvstop+190,
yycrank+501,	yysvec+10,	yyvstop+192,
yycrank+503,	yysvec+10,	yyvstop+194,
yycrank+505,	yysvec+10,	yyvstop+196,
yycrank+510,	yysvec+10,	yyvstop+198,
yycrank+502,	yysvec+10,	yyvstop+200,
yycrank+516,	yysvec+10,	yyvstop+202,
yycrank+522,	yysvec+10,	yyvstop+204,
yycrank+524,	yysvec+10,	yyvstop+206,
yycrank+527,	yysvec+10,	yyvstop+208,
yycrank+590,	0,		0,	
yycrank+0,	yysvec+96,	yyvstop+210,
yycrank+548,	yysvec+10,	yyvstop+212,
yycrank+549,	yysvec+10,	yyvstop+215,
yycrank+550,	yysvec+10,	yyvstop+218,
yycrank+551,	yysvec+10,	yyvstop+221,
yycrank+552,	yysvec+10,	yyvstop+223,
yycrank+553,	yysvec+10,	yyvstop+226,
yycrank+554,	yysvec+10,	yyvstop+228,
yycrank+555,	yysvec+10,	yyvstop+230,
yycrank+568,	yysvec+10,	yyvstop+232,
yycrank+566,	yysvec+10,	yyvstop+234,
yycrank+573,	yysvec+10,	yyvstop+237,
yycrank+569,	yysvec+10,	yyvstop+239,
yycrank+580,	yysvec+10,	yyvstop+242,
yycrank+575,	yysvec+10,	yyvstop+244,
yycrank+582,	yysvec+10,	yyvstop+247,
yycrank+584,	yysvec+10,	yyvstop+250,
yycrank+586,	yysvec+10,	yyvstop+253,
yycrank+587,	yysvec+10,	yyvstop+256,
0,	0,	0};
struct yywork *yytop = yycrank+697;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
040 ,'!' ,'!' ,'!' ,'!' ,'!' ,'!' ,'!' ,
'!' ,'!' ,'!' ,'+' ,'!' ,'+' ,'!' ,'!' ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,'!' ,'!' ,'!' ,'!' ,'!' ,'!' ,
'!' ,'A' ,'A' ,'A' ,'A' ,'E' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'!' ,'!' ,'!' ,'!' ,'!' ,
'!' ,'A' ,'A' ,'A' ,'A' ,'E' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'!' ,'!' ,'!' ,'!' ,01  ,
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
#ifndef lint
static	char ncform_sccsid[] = "@(#)ncform 1.6 88/02/08 SMI"; /* from S5R2 1.2 */
#endif

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
yyback(p, m)
	int *p;
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	}
yyoutput(c)
  int c; {
	output(c);
	}
yyunput(c)
   int c; {
	unput(c);
	}
