extern char *malloc(), *realloc();

# line 2 "gram.y"
/*
	yacc program -- for dfg to occam translation

AUTHOR:		L. A. Coon
ORGANIZATION:	Rochester Institute of Technology
EMAIL:		lac@cs.rit.edu

COPYRIGHT:	1994 Lawrence A. Coon
		All rights reserved.

		Permission to copy or use this software without fee is granted
		to non-profit and not-for-profit institutions and organizations
		provided that:

		1) such copying or use is not for commercial advantage, and
		2) no portion of this software is incorporated into any other
                   program or device for commercial advantage, and
		3) this copyright notice remains with the software.

		Permission is also granted to make this software available to
		other non-profit or not-for-profit institutions and
		organizations whose use satisfies (1) through (3) above.
		Any use of this software for commercial advantage, or
		incorporation of any part of this software into any other
		program or device for commercial advantage, or any use
		or copying other than by non-profit or not-for-profit
		institutions or organizations requires written permission of
		the copyright holder.

WARRANTY:	This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY.  Neither the author nor distributor
		accepts responsibility to anyone for the consequences of using
		it or for whether it serves any particular purpose or works at
		all.
*/

#include <stdio.h>
#include <strings.h>
#define TRUE 1
#define FALSE 0

/* import the file pointers declared in main */
extern FILE	*fpocc, *fpin, *fpout, *fpbod;

/* some needed globals */
int	lineno = 0;	/* keep count of line number for error reports	*/
char	*message;	/* holds message associated with an IO process	*/
double	value;		/* holds double associated with a constant	*/
int	instr_no;	/* holds instruction number: duplicates not ckd	*/
extern char *opcode_ptr;	/* pointer to opcode in opcode_array -- lex.l	*/

/*
 * stuff for handling input 'variables'
 */

/* flag that triggers printing of input var declaration line --
   FALSE until an input node is read, then TRUE	*/
int is_input =	FALSE;
/* flag that triggers printing of declaration of BOOL required by so.read --
   printing is done on 1st input, then flag is set to TRUE */
int is_bool =	FALSE;

char bool_error[] =	"  BOOL error :\n";
#define INPUT_STR	"  REAL64"
char input_buf[256] =	INPUT_STR;
char *input_start = 	input_buf + sizeof(INPUT_STR) - 1;
char *input_end = 	input_buf + sizeof(input_buf);
char *input_ptr;

# define CONST 257
# define MCONST 258
# define INPUT 259
# define MINPUT 260
# define COPY 261
# define MERGE 262
# define XMERGE 263
# define OUTPUT 264
# define MESSAGE 265
# define SWITCH 266
# define NOT 267
# define NEG 268
# define BIOP 269
# define EOS 270
# define INT 271
# define REAL 272
# define STRING 273
# define OTHER 274
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256
int yyexca[] ={
-1, 0,
	0, 1,
	271, 1,
	274, 1,
	-2, 0,
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 25
# define YYLAST 79
int yyact[]={

    17,    18,    21,    22,    19,    15,    16,     9,    10,    20,
    13,    12,    14,     6,    24,    40,     5,    34,    28,     8,
     7,     2,    39,    33,    23,    11,     4,     3,     1,    27,
     0,     0,     0,     0,     0,    25,    26,     0,     0,     0,
     0,     0,    35,    29,    30,    31,    32,     0,     0,    36,
    37,     0,    41,    42,    43,    44,    38,     0,     0,    47,
    48,    49,     0,    45,     0,    46,     0,     0,    50,    51,
     0,     0,     0,     0,     0,    54,    55,    52,    53 };
int yypact[]={

  -235,  -258,  -250,  -251,  -257, -1000, -1000, -1000, -1000,  -259,
  -259,  -259,  -253,  -253,  -253,  -253,  -253,  -255,  -255,  -253,
  -253, -1000, -1000, -1000, -1000, -1000,  -253,  -256, -1000,  -256,
  -256,  -256,  -256,  -253, -1000,  -253,  -256,  -256,  -256, -1000,
 -1000, -1000, -1000, -1000, -1000,  -256,  -256,  -253,  -253, -1000,
 -1000, -1000,  -256,  -256, -1000, -1000 };
int yypgo[]={

     0,    28,    27,    26,    24,    25,    29,    22,    23 };
int yyr1[]={

     0,     1,     1,     1,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     3,     6,
     7,     8,     4,     5,     5 };
int yyr2[]={

     0,     0,     6,     5,     5,     7,     7,    11,     9,     9,
     9,     9,     9,    11,    11,    13,    13,     2,     3,     2,
     2,     2,     2,     3,     3 };
int yychk[]={

 -1000,    -1,   256,    -2,    -3,   274,   271,   270,   270,   264,
   265,    -5,   268,   267,   269,   262,   263,   257,   258,   261,
   266,   259,   260,    -4,   273,    -4,    -4,    -6,   271,    -6,
    -6,    -6,    -6,    -8,   272,    -8,    -6,    -6,    -6,    -7,
   271,    -7,    -7,    -7,    -7,    -6,    -6,    -7,    -7,    -7,
    -7,    -7,    -6,    -6,    -7,    -7 };
int yydef[]={

    -2,    -2,     0,     0,     0,    17,    18,     3,     2,     4,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    23,    24,     5,    22,     6,     0,     0,    19,     0,
     0,     0,     0,     0,    21,     0,     0,     0,     0,     8,
    20,     9,    10,    11,    12,     0,     0,     0,     0,     7,
    13,    14,     0,     0,    15,    16 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"CONST",	257,
	"MCONST",	258,
	"INPUT",	259,
	"MINPUT",	260,
	"COPY",	261,
	"MERGE",	262,
	"XMERGE",	263,
	"OUTPUT",	264,
	"MESSAGE",	265,
	"SWITCH",	266,
	"NOT",	267,
	"NEG",	268,
	"BIOP",	269,
	"EOS",	270,
	"INT",	271,
	"REAL",	272,
	"STRING",	273,
	"OTHER",	274,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"pgm : /* empty */",
	"pgm : pgm stmt EOS",
	"pgm : error EOS",
	"stmt : inst_no OUTPUT",
	"stmt : inst_no OUTPUT string",
	"stmt : inst_no MESSAGE string",
	"stmt : inst_no input string node port",
	"stmt : inst_no NEG node port",
	"stmt : inst_no NOT node port",
	"stmt : inst_no BIOP node port",
	"stmt : inst_no MERGE node port",
	"stmt : inst_no XMERGE node port",
	"stmt : inst_no CONST value node port",
	"stmt : inst_no MCONST value node port",
	"stmt : inst_no COPY node port node port",
	"stmt : inst_no SWITCH node port node port",
	"stmt : OTHER",
	"inst_no : INT",
	"node : INT",
	"port : INT",
	"value : REAL",
	"string : STRING",
	"input : INPUT",
	"input : MINPUT",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free(yys); free(yyv); return(0); }
#define YYABORT		{ free(yys); free(yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 3:
# line 84 "gram.y"
{ printf("illegal instruction on line %d\n", lineno);	 } break;
case 4:
# line 87 "gram.y"
{	fprintf(fpout,"          C%d.1 ? outvar\n",instr_no);
			fprintf(fpout,"            SEQ\n");
			fprintf(fpout,
			"              so.write.real64(keyboard,screen,outvar,15,3)\n");
			fprintf(fpout,
			"              so.write.nl(keyboard,screen)\n");
		} break;
case 5:
# line 95 "gram.y"
{	fprintf(fpout,"          C%d.1 ? outvar\n",instr_no);
			fprintf(fpout,"            SEQ\n");
			fprintf(fpout,
			"              so.write.string(keyboard,screen,%s)\n", message);
			fprintf(fpout,
			"              so.write.real64(keyboard,screen,outvar,15,3)\n");
			fprintf(fpout,
			"              so.write.nl(keyboard,screen)\n");
		} break;
case 6:
# line 105 "gram.y"
{	fprintf(fpout,"          C%d.1 ? outvar\n",instr_no);
			fprintf(fpout,
			"            so.write.string.nl(keyboard,screen,%s)\n", message);
		} break;
case 7:
# line 110 "gram.y"
{	save_channel(yypvt[-1], yypvt[-0]);
			/* 1st time decl error variable needed by so.read */
			if ( ! is_bool )
			{
				fputs(bool_error,fpocc);
				is_bool = TRUE;
			}
			/* set/reset flag & input_ptr	*/
			if ( ! is_input )
			{
				is_input = TRUE;
				input_ptr = input_start;
			}
			/* check for input_buf overflow - limit of 99999 vars
			   the 10 is 5 chars for 'var', the space and the
			   comma and 5 for the integer	*/
			if ( input_ptr + 10 > input_end)
			{
				sprintf(--input_ptr," :\n");
				fputs(input_buf,fpocc);
				is_input = FALSE;
			}
			/* create the variable by placing on end of input_buf */
			sprintf(input_ptr," var%d,",instr_no);
			input_ptr = input_buf+strlen(input_buf);

			/* create the input code */
			fprintf(fpin,
			"    so.write.string(keyboard,screen,%s)\n", message);
			fprintf(fpin,
			"    so.read.echo.real64(keyboard,screen,var%d,error)\n", instr_no);
			fprintf(fpin,
			"    so.write.nl(keyboard,screen)\n");
			/* create the constant node procedure call */
			if (yypvt[-3] == INPUT)
				fprintf(fpbod,
				"      Const(var%d, C%d.%d)\n",instr_no,yypvt[-1],yypvt[-0]);
			else
				fprintf(fpbod,
				"      Mconst(var%d, C%d.%d)\n",instr_no,yypvt[-1],yypvt[-0]);
		} break;
case 8:
# line 152 "gram.y"
{	save_channel(yypvt[-1], yypvt[-0]);
			fprintf(fpbod,
			"      Neg(C%d.1, C%d.%d)\n",instr_no,yypvt[-1],yypvt[-0]);
		} break;
case 9:
# line 157 "gram.y"
{	save_channel(yypvt[-1], yypvt[-0]);
			fprintf(fpbod,
			"      Not(C%d.1, C%d.%d)\n",instr_no,yypvt[-1],yypvt[-0]);
		} break;
case 10:
# line 162 "gram.y"
{	save_channel(yypvt[-1], yypvt[-0]);
			fprintf(fpbod, "      %s(C%d.1, C%d.2, C%d.%d)\n",
				opcode_ptr, instr_no, instr_no, yypvt[-1], yypvt[-0]);
		} break;
case 11:
# line 167 "gram.y"
{	save_channel(yypvt[-1], yypvt[-0]);
			fprintf(fpbod,
			"      Merge(C%d.1, C%d.2, C%d.3, C%d.%d)\n",
				instr_no,instr_no,instr_no,yypvt[-1],yypvt[-0]);
		} break;
case 12:
# line 173 "gram.y"
{	save_channel(yypvt[-1], yypvt[-0]);
			fprintf(fpbod,
			"      Xmerge(C%d.1, C%d.2, C%d.%d)\n",
				instr_no,instr_no,yypvt[-1],yypvt[-0]);
		} break;
case 13:
# line 179 "gram.y"
{	save_channel(yypvt[-1], yypvt[-0]);
			fprintf(fpbod,
			"      Const(%f(REAL64), C%d.%d)\n",value,yypvt[-1],yypvt[-0]);
		} break;
case 14:
# line 184 "gram.y"
{	save_channel(yypvt[-1], yypvt[-0]);
			fprintf(fpbod,
			"      Mconst(%f(REAL64), C%d.%d)\n",value,yypvt[-1],yypvt[-0]);
		} break;
case 15:
# line 189 "gram.y"
{	save_channel(yypvt[-3], yypvt[-2]);
			save_channel(yypvt[-1], yypvt[-0]);
			fprintf(fpbod,
			"      Copy(C%d.1, C%d.%d, C%d.%d)\n",
				instr_no,yypvt[-3],yypvt[-2],yypvt[-1],yypvt[-0]);
		} break;
case 16:
# line 196 "gram.y"
{	save_channel(yypvt[-3], yypvt[-2]);
			save_channel(yypvt[-1], yypvt[-0]);
			fprintf(fpbod,
			"      Switch(C%d.1, C%d.2, C%d.%d, C%d.%d)\n",
				instr_no,instr_no,yypvt[-3],yypvt[-2],yypvt[-1],yypvt[-0]);
		} break;
case 18:
# line 205 "gram.y"
{ instr_no = yylval;	} break;
case 23:
# line 216 "gram.y"
{	yyval = INPUT;	} break;
case 24:
# line 218 "gram.y"
{	yyval = MINPUT;	} break;
	}
	goto yystack;		/* reset registers in driver code */
}
